#ifndef	__SIMPLEFILE_H__
#define	__SIMPLEFILE_H__

#if defined(_MSC_VER)
#pragma once
#endif

template <class TSimpleFileImpl>
class CSimpleFile : public TSimpleFileImpl
{
public:
    bool Open( const TCHAR * fileName, const TCHAR * mode)
    {
        return TSimpleFileImpl::Open( fileName, mode);
    }

    void Close()
    {
        TSimpleFileImpl::Close();
    }

    bool SeekCur( long offs)
    {
        return TSimpleFileImpl::SeekCur( offs);
    }

    bool SeekEnd( long offs)
    {
        return TSimpleFileImpl::SeekEnd( offs);
    }

    bool SeekBeg( long offs)
    {
        return TSimpleFileImpl::SeekBeg( offs);
    }

    size_t Read( void * buffer, size_t bufSize)
    {
        return TSimpleFileImpl::Read( buffer, bufSize);
    }

    BYTE ReadByte()
    {
        BYTE b;
        if (Read( &b, sizeof(b)) == sizeof(b))
            return b;
        else
            return -1;
    }

    WORD ReadWord()
    {
        WORD w;
        if (Read( &w, sizeof(w)) == sizeof(w))
            return w;
        else
            return -1;
    }

    DWORD ReadDWord()
    {
        DWORD dw;
        if (Read( &dw, sizeof(dw)) == sizeof(dw))
            return dw;
        else
            return -1;
    }

    char ReadChar()
    {
        return ReadByte();
    }

    wchar_t ReadWChar()
    {
        return ReadWord();
    }

    size_t Write( const void * buffer, size_t bufSize)
    {
        return TSimpleFileImpl::Write( buffer, bufSize);
    }

    bool WriteByte( BYTE b)
    {
        return (Write( &b, sizeof(b)) == sizeof(b));
    }

    bool WriteWord( WORD w)
    {
        return (Write( &w, sizeof(w)) == sizeof(w));
    }

    bool WriteDWord( DWORD dw)
    {
        return (Write( &dw, sizeof(dw)) == sizeof(dw));
    }

    bool WriteChar( char c)
    {
        return WriteByte( c);
    }

    bool WriteWChar( wchar_t wc)
    {
        return WriteWord( wc);
    }

    long Tell()
    {
        return TSimpleFileImpl::Tell();
    }

    bool IsEof() const
    {
        return TSimpleFileImpl::IsEof();
    }

    bool IsError() const
    {
        return TSimpleFileImpl::IsError();
    }

    bool operator!() const
    {
        return TSimpleFileImpl::operator!();
    }

    operator bool() const
    {
        return TSimpleFileImpl::operator bool();
    }
};

#if defined(__SIMPLESTDIOFILE_H__)
typedef CSimpleFile< CSimpleStdioFileImpl> CSimpleStdioFile;
#endif

#if defined(__SIMPLEMMAPPEDFILE_H__)
typedef CSimpleFile< CSimpleMemoryMappedFileImpl> CSimpleMemoryMappedFile;
#endif

#endif // __SIMPLEFILE_H__
